glibmm: Gio::TlsClientConnectionImpl Class Reference

glibmm 2.70.0

Public Member Functions | Protected Member Functions | List of all members
Gio::TlsClientConnectionImpl Class Reference

Gio::TlsClientConnectionImpl is a Gio::TlsConnection that implements the Gio::TlsClientConnection interface. More...

`#include <giomm/tlsclientconnectionimpl.h>`

Inheritance diagram for Gio::TlsClientConnectionImpl:
[legend]

## Public Member Functions
| TlsClientConnectionImpl (TlsClientConnectionImpl && src) noexcept
TlsClientConnectionImpl & | operator= (TlsClientConnectionImpl && src) noexcept
| ~TlsClientConnectionImpl () noexcept override
Public Member Functions inherited from Gio::TlsClientConnection
| TlsClientConnection (TlsClientConnection && src) noexcept
TlsClientConnection & | operator= (TlsClientConnection && src) noexcept
| ~TlsClientConnection () noexcept override
GTlsClientConnection * | gobj ()
| Provides access to the underlying C GObject. More...
const GTlsClientConnection * | gobj () const
| Provides access to the underlying C GObject. More...
void | set_server_identity (const Glib::RefPtr< SocketConnectable > & identity)
| Sets conn's expected server identity, which is used both to tell servers on virtual hosts which certificate to present, and also to let conn know what name to look for in the certificate when performing Gio::TlsCertificateFlags::BAD_IDENTITY validation, if enabled. More...
Glib::RefPtr< SocketConnectable > | get_server_identity ()
| Gets conn's expected server identity. More...
Glib::RefPtr< const SocketConnectable > | get_server_identity () const
| Gets conn's expected server identity. More...
void | set_validation_flags (TlsCertificateFlags flags)
| Sets conn's validation flags, to override the default set of checks performed when validating a server certificate. More...
TlsCertificateFlags | get_validation_flags () const
| Gets conn's validation flags. More...
std::vector< Glib::RefPtr< Glib::ByteArray > > | get_accepted_cas ()
| Gets the list of distinguished names of the Certificate Authorities that the server will accept certificates from. More...
std::vector< Glib::RefPtr< const Glib::ByteArray > > | get_accepted_cas () const
| Gets the list of distinguished names of the Certificate Authorities that the server will accept certificates from. More...
void | copy_session_state (const Glib::RefPtr< TlsClientConnection > & source)
| Possibly copies session state from one connection to another, for use in TLS session resumption. More...
Glib::PropertyProxy< Glib::RefPtr< SocketConnectable > > | property_server_identity ()
| A SocketConnectable describing the identity of the server that is expected on the other end of the connection. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SocketConnectable > > | property_server_identity () const
| A SocketConnectable describing the identity of the server that is expected on the other end of the connection. More...
Glib::PropertyProxy< TlsCertificateFlags > | property_validation_flags ()
| What steps to perform when validating a certificate received from a server. More...
Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > | property_validation_flags () const
| What steps to perform when validating a certificate received from a server. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject * castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject * | gobj ()
| Provides access to the underlying C GObject. More...
const GObject * | gobj () const
| Provides access to the underlying C GObject. More...
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::TlsConnection
| TlsConnection (TlsConnection && src) noexcept
TlsConnection & | operator= (TlsConnection && src) noexcept
| ~TlsConnection () noexcept override
GTlsConnection * | gobj ()
| Provides access to the underlying C GObject. More...
const GTlsConnection * | gobj () const
| Provides access to the underlying C GObject. More...
GTlsConnection * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_certificate (const Glib::RefPtr< TlsCertificate > & certificate)
| This sets the certificate that conn will present to its peer during the TLS handshake. More...
Glib::RefPtr< TlsCertificate > | get_certificate ()
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
Glib::RefPtr< const TlsCertificate > | get_certificate () const
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
Glib::RefPtr< TlsCertificate > | get_peer_certificate ()
| Gets conn's peer's certificate after the handshake has completed or failed. More...
Glib::RefPtr< const TlsCertificate > | get_peer_certificate () const
| Gets conn's peer's certificate after the handshake has completed or failed. More...
TlsCertificateFlags | get_peer_certificate_errors () const
| Gets the errors associated with validating conn's peer's certificate, after the handshake has completed or failed. More...
void | set_require_close_notify (bool require_close_notify=true)
| Sets whether or not conn expects a proper TLS close notification before the connection is closed. More...
bool | get_require_close_notify () const
| Tests whether or not conn expects a proper TLS close notification when the connection is closed. More...
Glib::RefPtr< TlsDatabase > | get_database ()
| Gets the certificate database that conn uses to verify peer certificates. More...
Glib::RefPtr< const TlsDatabase > | get_database () const
| Gets the certificate database that conn uses to verify peer certificates. More...
void | set_database (const Glib::RefPtr< TlsDatabase > & database)
| Sets the certificate database that is used to verify peer certificates. More...
Glib::RefPtr< TlsInteraction > | get_interaction ()
| Get the object that will be used to interact with the user. More...
Glib::RefPtr< const TlsInteraction > | get_interaction () const
| Get the object that will be used to interact with the user. More...
void | set_interaction (const Glib::RefPtr< TlsInteraction > & interaction)
| Set the object that will be used to interact with the user. More...
bool | handshake (const Glib::RefPtr< Cancellable > & cancellable)
| Attempts a TLS handshake on conn. More...
bool | handshake ()
| A handshake() convenience overload. More...
void | handshake_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Asynchronously performs a TLS handshake on conn. More...
void | handshake_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| A handshake_async() convenience overload. More...
bool | handshake_finish (const Glib::RefPtr< AsyncResult > & result)
| Finish an asynchronous TLS handshake operation. More...
TlsProtocolVersion | get_protocol_version () const
| Returns the current TLS protocol version, which may be Gio::TlsProtocolVersion::UNKNOWN if the connection has not handshaked, or has been closed, or if the TLS backend has implemented a protocol version that is not a recognized TlsProtocolVersion. More...
Glib::ustring | get_ciphersuite_name () const
| Returns the name of the current TLS ciphersuite, or `nullptr` if the connection has not handshaked or has been closed. More...
bool | emit_accept_certificate (const Glib::RefPtr< const TlsCertificate > & peer_cert, TlsCertificateFlags errors)
| Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< IOStream > > | property_base_io_stream () const
| The IOStream that the connection wraps. More...
Glib::PropertyProxy< Glib::RefPtr< TlsCertificate > > | property_certificate ()
| The connection's certificate; see g_tls_connection_set_certificate(). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_certificate () const
| The connection's certificate; see g_tls_connection_set_certificate(). More...
Glib::PropertyProxy< Glib::RefPtr< TlsDatabase > > | property_database ()
| The certificate database to use when verifying this TLS connection. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsDatabase > > | property_database () const
| The certificate database to use when verifying this TLS connection. More...
Glib::PropertyProxy< Glib::RefPtr< TlsInteraction > > | property_interaction ()
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsInteraction > > | property_interaction () const
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_peer_certificate () const
| The connection's peer's certificate, after the TLS handshake has completed or failed. More...
Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > | property_peer_certificate_errors () const
| The errors noticed while verifying TlsConnection::property_peer_certificate(). More...
Glib::PropertyProxy< bool > | property_require_close_notify ()
| Whether or not proper TLS close notification is required. More...
Glib::PropertyProxy_ReadOnly< bool > | property_require_close_notify () const
| Whether or not proper TLS close notification is required. More...
Glib::PropertyProxy_ReadOnly< TlsProtocolVersion > | property_protocol_version () const
| The TLS protocol version in use. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_ciphersuite_name () const
| The name of the TLS ciphersuite in use. More...
Glib::SignalProxy< bool(const Glib::RefPtr< const TlsCertificate > &, TlsCertificateFlags)> | signal_accept_certificate ()
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream && src) noexcept
IOStream & | operator= (IOStream && src) noexcept
| ~IOStream () noexcept override
GIOStream * | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream * | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable > & cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult > & result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)

## Protected Member Functions
| TlsClientConnectionImpl (GTlsConnection * castitem)
Protected Member Functions inherited from Gio::TlsClientConnection
| TlsClientConnection ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::TlsConnection
| TlsConnection ()
virtual bool | handshake_vfunc (const Glib::RefPtr< Cancellable > & cancellable)
virtual void | handshake_async_vfunc (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority)
virtual bool | handshake_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
virtual bool | on_accept_certificate (const Glib::RefPtr< const TlsCertificate > & peer_cert, TlsCertificateFlags errors)
| This is a default handler for the signal signal_accept_certificate(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gio::IOStream
enum class | SpliceFlags { NONE = 0x0 , CLOSE_STREAM1 = (1 << 0) , CLOSE_STREAM2 = (1 << 1) , WAIT_FOR_BOTH = (1 << 2) }
| GIOStreamSpliceFlags determine how streams should be spliced. More...
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Static Public Member Functions inherited from Gio::TlsClientConnection
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< TlsClientConnectionImpl > | create (const Glib::RefPtr< IOStream > & base_io_stream, const Glib::RefPtr< const SocketConnectable > & server_identity)
| Creates a new TlsClientConnection wrapping base_io_stream (which must have pollable input and output streams) which is assumed to communicate with the server identified by server_identity. More...
static Glib::RefPtr< TlsClientConnectionImpl > | create (const Glib::RefPtr< IOStream > & base_io_stream)
| A create() convenience overload. More...
Static Public Member Functions inherited from Gio::TlsConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes an asynchronous io stream splice operation. More...
Related Functions inherited from Gio::TlsClientConnection
Glib::RefPtr< Gio::TlsClientConnection > | wrap (GTlsClientConnection * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::TlsConnection
Glib::RefPtr< Gio::TlsConnection > | wrap (GTlsConnection * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Detailed Description

Gio::TlsClientConnectionImpl is a Gio::TlsConnection that implements the Gio::TlsClientConnection interface.

The GTlsClientConnection interface can be implemented by C classes that derive from GTlsConnection. No public GLib class implements GTlsClientConnection. Some GLib functions, such as g_tls_client_connection_new(), return an object of a class which is derived from GTlsConnection and implements GTlsClientConnection. Since that C class is not public, it's not wrapped in a C++ class. A C object of such a class can be wrapped in a Gio::TlsClientConnectionImpl object. Gio::TlsClientConnectionImpl does not directly correspond to any GLib class.

This class is intended only for wrapping C objects returned from GLib functions.

Since glibmm 2.66:

## Constructor & Destructor Documentation

## ◆ TlsClientConnectionImpl() [1/2]

Gio::TlsClientConnectionImpl::TlsClientConnectionImpl | ( | GTlsConnection * | castitem | ) |
| explicitprotected

## ◆ TlsClientConnectionImpl() [2/2]

Gio::TlsClientConnectionImpl::TlsClientConnectionImpl | ( | TlsClientConnectionImpl && | src | ) |
| noexcept

## ◆ ~TlsClientConnectionImpl()

Gio::TlsClientConnectionImpl::~TlsClientConnectionImpl | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ operator=()

TlsClientConnectionImpl& Gio::TlsClientConnectionImpl::operator= | ( | TlsClientConnectionImpl && | src | ) |
| noexcept